/**
 * @file   fluid_cal_1d.cpp
 * @author TC <bestucang@gmail.com>
 * @date   Sun Jan 13 17:27:34 2019
 *
 * @brief  一维传热
 *
 *
 */

#include <iostream>

struct node
{
	int flag;
	double x, y, z, tem;
};

struct node *mesh(float LX, int numCell, int numPoint);	/// 划分网格
void init(node *point, int numPoint);			/// 初始化
void iter(node *point, int numIter, int numPoint);	/// 计算

int main()
{
	using namespace std;

	int i, j, numCell, numPoint, numIter;
	float LX;
	node *point;

	cout << "input length:";
	cin >> LX;
	cout << "input the number of cell:";
	cin >> numCell;
	cout << "input the number of iteration:";
	cin >> numIter;
	numPoint = numCell + 2;

	point = mesh(LX, numCell, numPoint);
	init(point, numPoint);
	iter(point, numIter, numPoint);

	for (i = 0; i < numPoint; i++)
		printf("point%d\t|x coord:%.3f\t| temper:%6.3f\n", i, point[i].x, point[i].flag, point[i].tem);

	return 0;
}

void iter(node *point, int numIter, int numPoint)
{
	int i, j;
	for (j = 0; j < numIter; j++)
		for (i = 1; i < numPoint - 1; i++)
			if (point[i].flag == 0)
				point[i].tem = (point[i-1].tem + point[i+1].tem) / 2;
			else if (point[i].flag == 1)
				point[i].tem = (2 * point[i+1].tem + point[i-1].tem) / 3;
			else
				point[i].tem = (2 * point[i-1].tem + point[i+1].tem) / 3;
}

void init(node *point, int numPoint)
{
	int i;
	point[1].flag = 2;
	point[numPoint-2].flag = 1;

	for (i = 2; i < numPoint - 2; i++)
		point[i].flag = 0;

	point[0].tem = 100;
	point[numPoint-1].tem = 200;
}

node *mesh(float LX, int numCell, int numPoint)
{
	int i;
	float deltaX;
	node *point = new struct node[numPoint];

	deltaX = LX / numCell;
	point[0].x = 0;
	point[1].x = deltaX / 2;
	point[numPoint-1].x = LX;

	for (i = 2; i < numPoint - 1; i++)
		point[i].x = point[i-1].x + deltaX;

	return point;
}
